class Roadfood::CLI

  def call
    Roadfood::Scraper.new.make_reviews
    # binding.pry
    puts ""
    puts "Welcome to the latest reviews from Roadfood.com."
    start
  end

  def start
    puts ""
    print_list
    puts""

    puts "What review would you like to see?"
    input = gets.strip

    review = Roadfood::Review.find(input.to_i)

    print_review(review)

    puts ""
    puts "Would you like to see another review? (y/n)"
    input = gets.strip.downcase
    if input == "y"
      puts ""
      start
    else
      puts "Ok, have a nice day!"
      exit
    end
  end

  def print_list
    Roadfood::Review.all.each.with_index(1) do |review, index|
      puts "#{index}. #{review.name} – #{review.city}, #{review.state}"
    end
  end

  def print_review(review)
    puts ""
    puts "------------ #{review.name} - #{review.city}, #{review.state} ------------"
    puts ""
    puts "Rating:               #{review.rating}"
    puts "Dishes to Try:        #{review.dishes_to_try}"
    puts "Address:              #{review.address}"
    puts "Restaurant Website:   #{review.website}"
    puts "Author:               #{review.author}"
    puts "Date Published:       #{review.date_published}"
    puts ""
    puts "Review:"
    puts "#{review.body}"
    puts ""
    puts "------------------------------------------------------------------"

  end

end
