class Roadfood::Review
  attr_accessor :name, :city, :state, :url, :rating, :author, :date_published, :body, :dishes_to_try, :website, :address

  @@all = []

  def initialize(name=nil, city=nil, state=nil, url=nil)
    @name = name
    @city = city
    @state = state
    @url = url
    @@all << self
  end

  def self.new_from_index_page(r)
    self.new(r.css("h2").text,
    r.css(".address").text.strip.split(",")[1].strip,
    r.css(".address").text.strip.split(",").last.strip,
    r.css("h2 a").attribute("href").value)
  end

  def self.all
    @@all
  end

  def self.find(index)
    self.all[index-1]
  end

  def doc
    @doc ||= Nokogiri::HTML(open(self.url))
  end

  def rating
    @rating ||= doc.css(".rf_rating_title").text.capitalize
  end

  def author
    @author ||= doc.css("span[itemprop=author]").text
  end

  def date_published
    @date_published ||= doc.css("span.rf_reviewed[itemprop=datePublished]").text.strip.gsub("| ", "")
  end

  def body
    @body ||= doc.css("div[itemprop=reviewBody]").text.strip
  end

  def dishes_to_try
    @dishes_to_try ||= doc.css(".rf_dish_name_read_post").collect {|dish| dish.text}.join(", ")
  end

  def website
    names = doc.css(".rf_section").children.css("div.rf_policy_name").collect {|name| name.text.strip}.include?("Website")

    if names == true
      @website ||= doc.css(".rf_policy_result a").attribute("href").value
    else
      @website ||= "None"
    end

  end

  def address
    @address ||= doc.css(".address").text.strip
  end

end
